using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;

using RMYY_CallCenter_Api.DB;

namespace RMYY_CallCenter_Api.DAL
{
    /// <summary>
    /// 数据访问类:T_Car_AssignWorkOrder
    /// </summary>
    public partial class T_Car_AssignWorkOrder
    {
        public T_Car_AssignWorkOrder()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Car_AssignWorkOrder");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Car_AssignWorkOrder");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Car_AssignWorkOrder(");
            strSql.Append("F_WorkOrderID,F_DriverCode,F_DriverName,F_CarId,F_CarName,F_DepartPlace,F_Destination,F_CreateTime,F_CloseTime,F_State,F_CreateUser,F_IsDelete,F_WorkOrderCode)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderID,@F_DriverCode,@F_DriverName,@F_CarId,@F_CarName,@F_DepartPlace,@F_Destination,@F_CreateTime,@F_CloseTime,@F_State,@F_CreateUser,@F_IsDelete,@F_WorkOrderCode)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderID", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_DriverCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DriverName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CarId", SqlDbType.Int,4),
                    new SqlParameter("@F_CarName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DepartPlace", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Destination", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CloseTime", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderCode", SqlDbType.NVarChar,50),
            };
            parameters[0].Value = model.F_WorkOrderID;
            parameters[1].Value = model.F_DriverCode;
            parameters[2].Value = model.F_DriverName;
            parameters[3].Value = model.F_CarId;
            parameters[4].Value = model.F_CarName;
            parameters[5].Value = model.F_DepartPlace;
            parameters[6].Value = model.F_Destination;
            parameters[7].Value = model.F_CreateTime;
            parameters[8].Value = model.F_CloseTime;
            parameters[9].Value = model.F_State;
            parameters[10].Value = model.F_CreateUser;
            parameters[11].Value = model.F_IsDelete;
            parameters[12].Value = model.F_WorkOrderCode;
            
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Car_AssignWorkOrder set ");
            strSql.Append("F_WorkOrderID=@F_WorkOrderID,");
            strSql.Append("F_DriverCode=@F_DriverCode,");
            strSql.Append("F_DriverName=@F_DriverName,");
            strSql.Append("F_CarId=@F_CarId,");
            strSql.Append("F_CarName=@F_CarName,");
            strSql.Append("F_DepartPlace=@F_DepartPlace,");
            strSql.Append("F_Destination=@F_Destination,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_CloseTime=@F_CloseTime,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_WorkOrderCode=@F_WorkOrderCode");
            
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderID", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_DriverCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DriverName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CarId", SqlDbType.Int,4),
                    new SqlParameter("@F_CarName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DepartPlace", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Destination", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CloseTime", SqlDbType.DateTime),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderID;
            parameters[1].Value = model.F_DriverCode;
            parameters[2].Value = model.F_DriverName;
            parameters[3].Value = model.F_CarId;
            parameters[4].Value = model.F_CarName;
            parameters[5].Value = model.F_DepartPlace;
            parameters[6].Value = model.F_Destination;
            parameters[7].Value = model.F_CreateTime;
            parameters[8].Value = model.F_CloseTime;
            parameters[9].Value = model.F_State;
            parameters[10].Value = model.F_CreateUser;
            parameters[11].Value = model.F_IsDelete;
            parameters[12].Value = model.F_WorkOrderCode
;
            parameters[13].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Car_AssignWorkOrder ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Car_AssignWorkOrder ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_WorkOrderID,F_WorkOrderCode,F_DriverCode,F_DriverName,F_CarId,F_CarName,F_DepartPlace,F_Destination,F_CreateTime,F_CloseTime,F_State,F_CreateUser,F_IsDelete from T_Car_AssignWorkOrder ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder model = new RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder model = new RMYY_CallCenter_Api.Model.T_Car_AssignWorkOrder();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_WorkOrderID"] != null)
                {
                    model.F_WorkOrderID = row["F_WorkOrderID"].ToString();
                }
                if (row["F_DriverCode"] != null)
                {
                    model.F_DriverCode = row["F_DriverCode"].ToString();
                }
                if (row["F_DriverName"] != null)
                {
                    model.F_DriverName = row["F_DriverName"].ToString();
                }
                if (row["F_CarId"] != null && row["F_CarId"].ToString() != "")
                {
                    model.F_CarId = int.Parse(row["F_CarId"].ToString());
                }
                if (row["F_CarName"] != null)
                {
                    model.F_CarName = row["F_CarName"].ToString();
                }
                if (row["F_DepartPlace"] != null)
                {
                    model.F_DepartPlace = row["F_DepartPlace"].ToString();
                }
                if (row["F_Destination"] != null)
                {
                    model.F_Destination = row["F_Destination"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_CloseTime"] != null && row["F_CloseTime"].ToString() != "")
                {
                    model.F_CloseTime = DateTime.Parse(row["F_CloseTime"].ToString());
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_WorkOrderCode"] != null)
                {
                    model.F_WorkOrderCode = row["F_WorkOrderCode"].ToString();
                }
                
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_WorkOrderID,F_DriverCode,F_WorkOrderCode,F_DriverName,F_CarId,F_CarName,F_DepartPlace,F_Destination,F_CreateTime,F_CloseTime,F_State,F_CreateUser,F_IsDelete ");
            strSql.Append(" FROM T_Car_AssignWorkOrder ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_WorkOrderID,F_DriverCode,F_DriverName,F_WorkOrderCode,F_CarId,F_CarName,F_DepartPlace,F_Destination,F_CreateTime,F_CloseTime,F_State,F_CreateUser,F_IsDelete ");
            strSql.Append(" FROM T_Car_AssignWorkOrder ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Car_AssignWorkOrder ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Car_AssignWorkOrder T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Car_AssignWorkOrder";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}